<?php

/*
* Plugin Name: Custom Admin Bar Menu
* Description: Menú personalizado para administradores.
* Version: 1.0
* Author: Miquel Camps Orteza
* Author URI: https://vivirenremoto.com
*/

// show settings

function customadmin_register_settings() {
   add_option( 'customadmin_option_header', '[]');
   register_setting( 'customadmin_options_group', 'customadmin_option_menu', 'customadmin_callback' );
}
add_action( 'admin_init', 'customadmin_register_settings' );


function customadmin_register_options_page() {
  add_options_page('Custom Admin Menu', 'Custom Admin Menu', 'manage_options', 'customadmin', 'customadmin_options_page');
}
add_action('admin_menu', 'customadmin_register_options_page');

function customadmin_callback($input){
	return json_encode($input);
}

function customadmin_options_page()
{

$menus = get_terms('nav_menu', array(
    'orderby' => 'id',
));

$customadmin_option_menu = get_option('customadmin_option_menu');

if( !$customadmin_option_menu ) $customadmin_option_menu = "[]";
$customadmin_option_menu = json_decode( $customadmin_option_menu );

?>


  <div class="notice notice-warning" style="margin:30px 0 30px 0">
    <p><a href="https://vivirenremoto.com/plugins-vip-wordpress/" target="_blank" style="color:black;font-weight:bold;text-decoration:none;">Descubre más plugins molones como este</p></a>
  </div>

  <div>

  <h2>Custom Admin Bar Menu</h2>
  <form method="post" action="options.php">
  <?php settings_fields( 'customadmin_options_group' ); ?>
  <table>
	  <tr class="form-field">
	    <th scope="row" valign="top">
	        <label for="customadmin_option_menu">Menús</label>
	    </th>
		  <td>
			<?php foreach ( $menus as $menu ): ?>
				<label><input type="checkbox" name="customadmin_option_menu[]" value="<?=$menu->term_id?>" <?php if( in_array($menu->term_id, $customadmin_option_menu) ): ?>checked="checked"<?php endif ?> > <?=$menu->name?></label><br><br>
			<?php endforeach ?>
		  </td>
	  </tr>
  </table>
  <?php  submit_button(); ?>
  </form>
  </div>
<?php
}

//////////////////////////////////////

// show custom menu

add_action('admin_bar_menu', 'admin_custom_menu', 1000);

function admin_custom_menu()
{
	global $wp_admin_bar;

				    
	if(!is_super_admin() || !is_admin_bar_showing()) return;

	$customadmin_option_menu = get_option('customadmin_option_menu');
	if( $customadmin_option_menu ){

		$customadmin_option_menu = json_decode($customadmin_option_menu);
		if( $customadmin_option_menu ){

			foreach( $customadmin_option_menu as $term_id ){

				$term = get_term( $term_id );
				if( $term ){
				    $menu_id = 'myCustomMenu' . $term_id;

				    $argsParent = array(
				        'id' => $menu_id,
				        'title' => $term->name,
				        'href' => false
				    );
				    $wp_admin_bar->add_menu($argsParent);

					$items = get_objects_in_term($term_id, 'nav_menu' );

					if( $items ){
						$menues = wp_get_nav_menu_items($term_id);

						foreach($menues as $menu){

							if( $menu->menu_item_parent == 0 ){
								$parent_id = $menu_id;
							}else{
								$parent_id = 'submenu' . $menu->menu_item_parent;
							}


						    $argsSub1 = array(
						    	'id' => 'submenu' . $menu->ID,
						        'parent' => $parent_id,
						        'title' => $menu->title,
						        'href' => $menu->url,
						        'meta' => array('target' => $menu->target)
						    );
						    $wp_admin_bar->add_menu($argsSub1);
						}


					}
				}

			}

		}


	}



}

